﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace ParentRootInteraction
{
	public partial class ChildControl : UserControl
	{
		public ChildControl()
		{
			// Required to initialize variables
			InitializeComponent();

            this.Loaded += new RoutedEventHandler(ChildControl_Loaded);
		}

        void ChildControl_Loaded(object sender, RoutedEventArgs e)
        {
            MainPage rootPage = this.FindParentByType<MainPage>();
			rootPage.RootMessage();
        }
	}

    public static class TreeHelper
    {
        public static T FindParentByType<T>(this DependencyObject child) where T : DependencyObject
        {
            Type type = typeof(T);
            DependencyObject parent = VisualTreeHelper.GetParent(child);

            if (parent == null)
            {
                return null;
            }
            else if (parent.GetType() == type)
            {
                return parent as T;
            }
            else
            {
                return parent.FindParentByType<T>();
            }
        }
    }
}